  Sketchup::require 'sketchup'
  Sketchup::require 'extensions'
  Sketchup::require 'langhandler'
  Sketchup::require 'json'
  Sketchup::require 'singleton'
  Sketchup::require 'base64'
  Sketchup::require 'tmpdir'
  Sketchup::require 'securerandom'
  Sketchup::require 'net/http'
  Sketchup::require 'openssl'
  Sketchup::require 'ostruct'
  Sketchup::require 'date'

  current_path = __dir__.dup
  current_path.force_encoding('UTF-8') if current_path.respond_to?(:force_encoding)

  extension_file = __FILE__.dup
  extension_file.force_encoding('UTF-8') if extension_file.respond_to?(:force_encoding)

  module Adebeo
    module Simpletool
      LH = LanguageHandler.new("AdebeoSimpleToolExtension.strings").freeze

      WIN = Sketchup.platform == :platform_win
      MAC = !WIN

      # x86 vs x64
      PLATFORM_IS_64BIT = (Sketchup.respond_to?(:is_64bit?) && Sketchup.is_64bit?).freeze
      PLATFORM_IS_32_BIT = (!PLATFORM_IS_64BIT).freeze
      PLUGIN = self
      VERSION = "3.14.0"
    end
  end

  unless file_loaded?(extension_file)

    extension_path = File.join(current_path,"adebeo_simpleTool","adebeo_simpleTool.rbe")

    if !File.exist? extension_path
      extension_path = File.join(current_path,"adebeo_simpleTool","adebeo_simpleTool.rb")
    end

    ext = SketchupExtension.new('SimpleTool',extension_path)
    # Attach some nice info.
    ext.creator     = 'Adebeo, Inc.'
    ext.version     = Adebeo::Simpletool::VERSION
    ext.copyright   = '2024 Adebeo, Inc.'
    ext.description = 'Adebeo Simple Tool to help beginner'

    #SKETCHUP_CONSOLE.show

    # Register and load the extension on startup.
    Sketchup.register_extension ext, true
  end

=begin

to do

-> simple move avec clavier
-> replace windows on none perpendicular wall
-> distance mur sur mur
-> resolution with 2 screen
-> perçeuse
-> profil
-> sol
-> layout
-> IGN
-> mis à plat
-> arrow for align
to be increase

  -> mur en biso, face non parrallele
  -> simple rotate
  -> icon en svg pdf

Prefer a full sentence statusbar text description for commands, in addition to the title case title.
Note: For toolbar buttons,
 prefer a short title case title such as "Connected Walls" and
 a sentence case status bar text such as "Draw multiple continuous wall segments.".
 https://sketchup.github.io/sketchup-extension-ux-guidelines/#tooltipsdescriptions

3.14
debug simple align

3.13
Sketchup 2024

3.12
remove exists method

3.11
add licence

3.10
licence update

3.9.6
change casse name

3.9.5
add 2023 release

3.9.4
add 2022 release

3.9.3
add component

3.9.2
correction du regexp du mur

3.9.1
remove material in case of options
MF_DISABLED instead of MF_CHECKED

3.9
bug on offset and grey scaled
bug on selecte component

3.8.8
bug on sketchup require

3.8.7
remove comment

3.8.6
add comonent in lib

3.8.5
forced simple_move_offset_x / simple_move_offset_y
Note: The statusbar text is missing after tools have been interrupted by the camera tools.
change dimension after wall
You can call the method setting the toolbar text in the resume method.

3.8.4
start dimension on wall
re-init folder stick opening and insert

3.8.3
activation tool
Note: Prefer showing buttons as depressed for as long as the tool is active.
Note: Minor detail, but I'd put the two Wall tools next to each other in the toolbar,
 and make openign and door/windows neighbors.


3.8.2
-> bug when DC are not active "xscale"

3.8.1
-> traduction improvement for licence update
-> exlude some old files because sketchup extension updater merge folder instead of replace it
-> add a missing strat operation/commit when user add a windows with only 1 parameter

3.8.0
Add push line
don't display dimension and face when insert windows are on windowds
check windows surface before display windows

3.7.20
texture on floor inside the wall

3.7.19
correction on small wall

3.7.18
allow hals demission . user can enter ";20cm" instead of copying the actuel length and ;20cm

3.7.17

3.7.16
-> bug on sur angle

3.7.15
add kitchen librabry

3.7.14
-> make uniq
-> distance max to opening
-> distance from windows on wall in model
-> autorized area on face non-otho

3.7.13
amélioration sur remplacement sur IFC covering

3.7.12
start translation

3.7.11
memory bug


3.7.9
refacto for extension warehouse

Please wrap all Ruby files in the extension module to avoid clashes with other extensions.
Currently ComponentSkeleton, AdebeoSimpletoolOpenObserver, SimpletoolWallObserver and SimpletoolWindowsObserver are defined at the global level. Rejection:
Note: The extension title differs between the title and description.
For a consistent Undo behavior, the transparent parameter should be true in 'model.start_operation " after move wall", true'.
Rejection When activating any of the tools I get Ruby errors written in the console: Error: #<NoMethodError: undefined method `valid?' for nil:NilClass>
c:/users/cenerot/appdata/roaming/sketchup/sketchup 2021/sketchup/plugins/adebeo_simpletool/controlers/05_wall_tool.rbe:296:in `draw'
Note: Prefer a nicely formatted toolbar title (title case),not an all lowercase one with underscores between the words. Note:
Note: The native SketchUp material tool is called "Paint Bucket tool", not "bucket tool".


3.7.8
bug correction et refacto triangle

3.7.7
change alt to shift

3.7.6
affichage align


3.7.5
networks with drag

3.7.4
insert on top

3.7.3
wall without classification

3.7.2
bug on model when element doesn't exist

3.7.1
when parent doesn t exist

3.7
debug on free lib

3.6
debug on post contrustvion
add windows inside parante face

3.5
  -> glob
3.4
  -> verrouillé l'inférence
  -> forget licence
  -> lorsqu'on sort d'un biblitohque on devrait reprendre le meme que pécédement

3.3.2
  -> debug répertoire par default

3.3.1
 remove option

3.3
 increase filter, mouse wheel

3.2
 filter component

3.1
 observer for windows and wall

3.0
 add constrain and limit

2.8
 scaling

2.7
 list comp

2.6
 display on floor

2.4
-> chemin miniature


0.2.3
debug

0.2.1
affichage lib

0.2.0
add material replacement

0.1.0
selection du dossier

0.0.0
=> encryption

=end
